/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../common";

export declare namespace OspDataTypes {
  export type ContentReactionDataStruct = {
    reactionType: PromiseOrValue<BigNumberish>;
    profileId: PromiseOrValue<BigNumberish>;
    contentURI: PromiseOrValue<string>;
    referencedProfileId: PromiseOrValue<BigNumberish>;
    referencedContentId: PromiseOrValue<BigNumberish>;
    referenceModuleData: PromiseOrValue<BytesLike>;
    referenceModule: PromiseOrValue<string>;
    referenceModuleInitData: PromiseOrValue<BytesLike>;
  };

  export type ContentReactionDataStructOutput = [
    number,
    BigNumber,
    string,
    BigNumber,
    BigNumber,
    string,
    string,
    string
  ] & {
    reactionType: number;
    profileId: BigNumber;
    contentURI: string;
    referencedProfileId: BigNumber;
    referencedContentId: BigNumber;
    referenceModuleData: string;
    referenceModule: string;
    referenceModuleInitData: string;
  };

  export type EIP712SignatureStruct = {
    v: PromiseOrValue<BigNumberish>;
    r: PromiseOrValue<BytesLike>;
    s: PromiseOrValue<BytesLike>;
    deadline: PromiseOrValue<BigNumberish>;
  };

  export type EIP712SignatureStructOutput = [
    number,
    string,
    string,
    BigNumber
  ] & { v: number; r: string; s: string; deadline: BigNumber };

  export type ContentReactionWithSigDataStruct = {
    reactionType: PromiseOrValue<BigNumberish>;
    profileId: PromiseOrValue<BigNumberish>;
    contentURI: PromiseOrValue<string>;
    referencedProfileId: PromiseOrValue<BigNumberish>;
    referencedContentId: PromiseOrValue<BigNumberish>;
    referenceModuleData: PromiseOrValue<BytesLike>;
    referenceModule: PromiseOrValue<string>;
    referenceModuleInitData: PromiseOrValue<BytesLike>;
    sig: OspDataTypes.EIP712SignatureStruct;
  };

  export type ContentReactionWithSigDataStructOutput = [
    number,
    BigNumber,
    string,
    BigNumber,
    BigNumber,
    string,
    string,
    string,
    OspDataTypes.EIP712SignatureStructOutput
  ] & {
    reactionType: number;
    profileId: BigNumber;
    contentURI: string;
    referencedProfileId: BigNumber;
    referencedContentId: BigNumber;
    referenceModuleData: string;
    referenceModule: string;
    referenceModuleInitData: string;
    sig: OspDataTypes.EIP712SignatureStructOutput;
  };

  export type ReactionDataStruct = {
    reactionType: PromiseOrValue<BigNumberish>;
    profileId: PromiseOrValue<BigNumberish>;
    referencedProfileId: PromiseOrValue<BigNumberish>;
    referencedContentId: PromiseOrValue<BigNumberish>;
    referenceModuleData: PromiseOrValue<BytesLike>;
    data: PromiseOrValue<BytesLike>;
  };

  export type ReactionDataStructOutput = [
    number,
    BigNumber,
    BigNumber,
    BigNumber,
    string,
    string
  ] & {
    reactionType: number;
    profileId: BigNumber;
    referencedProfileId: BigNumber;
    referencedContentId: BigNumber;
    referenceModuleData: string;
    data: string;
  };

  export type ReactionWithSigDataStruct = {
    reactionType: PromiseOrValue<BigNumberish>;
    profileId: PromiseOrValue<BigNumberish>;
    referencedProfileId: PromiseOrValue<BigNumberish>;
    referencedContentId: PromiseOrValue<BigNumberish>;
    referenceModuleData: PromiseOrValue<BytesLike>;
    data: PromiseOrValue<BytesLike>;
    sig: OspDataTypes.EIP712SignatureStruct;
  };

  export type ReactionWithSigDataStructOutput = [
    number,
    BigNumber,
    BigNumber,
    BigNumber,
    string,
    string,
    OspDataTypes.EIP712SignatureStructOutput
  ] & {
    reactionType: number;
    profileId: BigNumber;
    referencedProfileId: BigNumber;
    referencedContentId: BigNumber;
    referenceModuleData: string;
    data: string;
    sig: OspDataTypes.EIP712SignatureStructOutput;
  };

  export type CollectWithSigDataStruct = {
    collector: PromiseOrValue<string>;
    profileId: PromiseOrValue<BigNumberish>;
    contentId: PromiseOrValue<BigNumberish>;
    data: PromiseOrValue<BytesLike>;
    sig: OspDataTypes.EIP712SignatureStruct;
  };

  export type CollectWithSigDataStructOutput = [
    string,
    BigNumber,
    BigNumber,
    string,
    OspDataTypes.EIP712SignatureStructOutput
  ] & {
    collector: string;
    profileId: BigNumber;
    contentId: BigNumber;
    data: string;
    sig: OspDataTypes.EIP712SignatureStructOutput;
  };
}

export interface ReactionLogicInterface extends utils.Interface {
  functions: {
    "addContentReaction((uint8,uint256,string,uint256,uint256,bytes,address,bytes))": FunctionFragment;
    "addContentReactionWithSig((uint8,uint256,string,uint256,uint256,bytes,address,bytes,(uint8,bytes32,bytes32,uint256)))": FunctionFragment;
    "addReaction((uint8,uint256,uint256,uint256,bytes,bytes))": FunctionFragment;
    "addReactionWithSig((uint8,uint256,uint256,uint256,bytes,bytes,(uint8,bytes32,bytes32,uint256)))": FunctionFragment;
    "collect(uint256,uint256,bytes)": FunctionFragment;
    "collectWithSig((address,uint256,uint256,bytes,(uint8,bytes32,bytes32,uint256)))": FunctionFragment;
    "emitCollectNFTTransferEvent(uint256,uint256,uint256,address,address)": FunctionFragment;
    "getReaction(uint8,uint256,uint256,uint256)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "addContentReaction"
      | "addContentReactionWithSig"
      | "addReaction"
      | "addReactionWithSig"
      | "collect"
      | "collectWithSig"
      | "emitCollectNFTTransferEvent"
      | "getReaction"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "addContentReaction",
    values: [OspDataTypes.ContentReactionDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "addContentReactionWithSig",
    values: [OspDataTypes.ContentReactionWithSigDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "addReaction",
    values: [OspDataTypes.ReactionDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "addReactionWithSig",
    values: [OspDataTypes.ReactionWithSigDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "collect",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BytesLike>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "collectWithSig",
    values: [OspDataTypes.CollectWithSigDataStruct]
  ): string;
  encodeFunctionData(
    functionFragment: "emitCollectNFTTransferEvent",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<string>,
      PromiseOrValue<string>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "getReaction",
    values: [
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>
    ]
  ): string;

  decodeFunctionResult(
    functionFragment: "addContentReaction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "addContentReactionWithSig",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "addReaction",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "addReactionWithSig",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "collect", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "collectWithSig",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "emitCollectNFTTransferEvent",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getReaction",
    data: BytesLike
  ): Result;

  events: {};
}

export interface ReactionLogic extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: ReactionLogicInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    addContentReaction(
      vars: OspDataTypes.ContentReactionDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    addContentReactionWithSig(
      vars: OspDataTypes.ContentReactionWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    addReaction(
      vars: OspDataTypes.ReactionDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    addReactionWithSig(
      vars: OspDataTypes.ReactionWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    collect(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    collectWithSig(
      vars: OspDataTypes.CollectWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    emitCollectNFTTransferEvent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      collectNFTId: PromiseOrValue<BigNumberish>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    getReaction(
      reactionType: PromiseOrValue<BigNumberish>,
      profileId: PromiseOrValue<BigNumberish>,
      referencedProfileId: PromiseOrValue<BigNumberish>,
      referencedContentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;
  };

  addContentReaction(
    vars: OspDataTypes.ContentReactionDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  addContentReactionWithSig(
    vars: OspDataTypes.ContentReactionWithSigDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  addReaction(
    vars: OspDataTypes.ReactionDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  addReactionWithSig(
    vars: OspDataTypes.ReactionWithSigDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  collect(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    data: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  collectWithSig(
    vars: OspDataTypes.CollectWithSigDataStruct,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  emitCollectNFTTransferEvent(
    profileId: PromiseOrValue<BigNumberish>,
    contentId: PromiseOrValue<BigNumberish>,
    collectNFTId: PromiseOrValue<BigNumberish>,
    from: PromiseOrValue<string>,
    to: PromiseOrValue<string>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  getReaction(
    reactionType: PromiseOrValue<BigNumberish>,
    profileId: PromiseOrValue<BigNumberish>,
    referencedProfileId: PromiseOrValue<BigNumberish>,
    referencedContentId: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  callStatic: {
    addContentReaction(
      vars: OspDataTypes.ContentReactionDataStruct,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    addContentReactionWithSig(
      vars: OspDataTypes.ContentReactionWithSigDataStruct,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    addReaction(
      vars: OspDataTypes.ReactionDataStruct,
      overrides?: CallOverrides
    ): Promise<void>;

    addReactionWithSig(
      vars: OspDataTypes.ReactionWithSigDataStruct,
      overrides?: CallOverrides
    ): Promise<void>;

    collect(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    collectWithSig(
      vars: OspDataTypes.CollectWithSigDataStruct,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    emitCollectNFTTransferEvent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      collectNFTId: PromiseOrValue<BigNumberish>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;

    getReaction(
      reactionType: PromiseOrValue<BigNumberish>,
      profileId: PromiseOrValue<BigNumberish>,
      referencedProfileId: PromiseOrValue<BigNumberish>,
      referencedContentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;
  };

  filters: {};

  estimateGas: {
    addContentReaction(
      vars: OspDataTypes.ContentReactionDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    addContentReactionWithSig(
      vars: OspDataTypes.ContentReactionWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    addReaction(
      vars: OspDataTypes.ReactionDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    addReactionWithSig(
      vars: OspDataTypes.ReactionWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    collect(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    collectWithSig(
      vars: OspDataTypes.CollectWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    emitCollectNFTTransferEvent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      collectNFTId: PromiseOrValue<BigNumberish>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    getReaction(
      reactionType: PromiseOrValue<BigNumberish>,
      profileId: PromiseOrValue<BigNumberish>,
      referencedProfileId: PromiseOrValue<BigNumberish>,
      referencedContentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    addContentReaction(
      vars: OspDataTypes.ContentReactionDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    addContentReactionWithSig(
      vars: OspDataTypes.ContentReactionWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    addReaction(
      vars: OspDataTypes.ReactionDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    addReactionWithSig(
      vars: OspDataTypes.ReactionWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    collect(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      data: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    collectWithSig(
      vars: OspDataTypes.CollectWithSigDataStruct,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    emitCollectNFTTransferEvent(
      profileId: PromiseOrValue<BigNumberish>,
      contentId: PromiseOrValue<BigNumberish>,
      collectNFTId: PromiseOrValue<BigNumberish>,
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    getReaction(
      reactionType: PromiseOrValue<BigNumberish>,
      profileId: PromiseOrValue<BigNumberish>,
      referencedProfileId: PromiseOrValue<BigNumberish>,
      referencedContentId: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
